/*----- PROTECTED REGION ID(Agilent4uhvClass.h) ENABLED START -----*/
//=============================================================================
//
// file :        Agilent4uhvClass.h
//
// description : Include for the Agilent4uhv root class.
//               This class is the singleton class for
//                the Agilent4uhv device class.
//               It contains all properties and methods which the 
//               Agilent4uhv requires only once e.g. the commands.
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: alessio $
//
// $Revision: 1.8 $
// $Date: 2016-05-23 07:50:11 $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef Agilent4uhvClass_H
#define Agilent4uhvClass_H

#include <tango.h>
#include <Serial2ClientClass.h>
#include <Agilent4uhv.h>


/*----- PROTECTED REGION END -----*/	//	Agilent4uhvClass.h


namespace Agilent4uhv_ns
{
/*----- PROTECTED REGION ID(Agilent4uhvClass::classes for dynamic creation) ENABLED START -----*/


/*----- PROTECTED REGION END -----*/	//	Agilent4uhvClass::classes for dynamic creation

//=========================================
//	Define classes for attributes
//=========================================
//	Attribute Model class definition
class ModelAttrib: public Tango::Attr
{
public:
	ModelAttrib():Attr("Model",
			Tango::DEV_STRING, Tango::READ) {};
	~ModelAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent4uhv *>(dev))->read_Model(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent4uhv *>(dev))->is_Model_allowed(ty);}
};

//	Attribute SerialNumber class definition
class SerialNumberAttrib: public Tango::Attr
{
public:
	SerialNumberAttrib():Attr("SerialNumber",
			Tango::DEV_STRING, Tango::READ) {};
	~SerialNumberAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent4uhv *>(dev))->read_SerialNumber(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent4uhv *>(dev))->is_SerialNumber_allowed(ty);}
};

//	Attribute Temperature class definition
class TemperatureAttrib: public Tango::Attr
{
public:
	TemperatureAttrib():Attr("Temperature",
			Tango::DEV_FLOAT, Tango::READ) {};
	~TemperatureAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent4uhv *>(dev))->read_Temperature(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent4uhv *>(dev))->is_Temperature_allowed(ty);}
};


//=========================================
//	Define classes for dynamic attributes
//=========================================
//	Attribute HVX class definition
class HVXAttrib: public Tango::Attr
{
public:
	HVXAttrib(const string &att_name):Attr(att_name.c_str(), 
			Tango::DEV_STATE, Tango::READ) {};
	~HVXAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent4uhv *>(dev))->read_HVX(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent4uhv *>(dev))->is_HVX_allowed(ty);}
};

//	Attribute DeviceNumberX class definition
class DeviceNumberXAttrib: public Tango::Attr
{
public:
	DeviceNumberXAttrib(const string &att_name):Attr(att_name.c_str(), 
			Tango::DEV_LONG, Tango::READ_WRITE) {};
	~DeviceNumberXAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent4uhv *>(dev))->read_DeviceNumberX(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Agilent4uhv *>(dev))->write_DeviceNumberX(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent4uhv *>(dev))->is_DeviceNumberX_allowed(ty);}
};

//	Attribute PowerMaxX class definition
class PowerMaxXAttrib: public Tango::Attr
{
public:
	PowerMaxXAttrib(const string &att_name):Attr(att_name.c_str(), 
			Tango::DEV_USHORT, Tango::READ_WRITE) {};
	~PowerMaxXAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent4uhv *>(dev))->read_PowerMaxX(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Agilent4uhv *>(dev))->write_PowerMaxX(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent4uhv *>(dev))->is_PowerMaxX_allowed(ty);}
};

//	Attribute VTargetX class definition
class VTargetXAttrib: public Tango::Attr
{
public:
	VTargetXAttrib(const string &att_name):Attr(att_name.c_str(), 
			Tango::DEV_USHORT, Tango::READ_WRITE) {};
	~VTargetXAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent4uhv *>(dev))->read_VTargetX(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Agilent4uhv *>(dev))->write_VTargetX(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent4uhv *>(dev))->is_VTargetX_allowed(ty);}
};

//	Attribute IProtectX class definition
class IProtectXAttrib: public Tango::Attr
{
public:
	IProtectXAttrib(const string &att_name):Attr(att_name.c_str(), 
			Tango::DEV_USHORT, Tango::READ_WRITE) {};
	~IProtectXAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent4uhv *>(dev))->read_IProtectX(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Agilent4uhv *>(dev))->write_IProtectX(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent4uhv *>(dev))->is_IProtectX_allowed(ty);}
};

//	Attribute SetPointX class definition
class SetPointXAttrib: public Tango::Attr
{
public:
	SetPointXAttrib(const string &att_name):Attr(att_name.c_str(), 
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~SetPointXAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent4uhv *>(dev))->read_SetPointX(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Agilent4uhv *>(dev))->write_SetPointX(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent4uhv *>(dev))->is_SetPointX_allowed(ty);}
};

//	Attribute TemperatureHVX class definition
class TemperatureHVXAttrib: public Tango::Attr
{
public:
	TemperatureHVXAttrib(const string &att_name):Attr(att_name.c_str(), 
			Tango::DEV_FLOAT, Tango::READ) {};
	~TemperatureHVXAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent4uhv *>(dev))->read_TemperatureHVX(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent4uhv *>(dev))->is_TemperatureHVX_allowed(ty);}
};

//	Attribute VoltageX class definition
class VoltageXAttrib: public Tango::Attr
{
public:
	VoltageXAttrib(const string &att_name):Attr(att_name.c_str(), 
			Tango::DEV_DOUBLE, Tango::READ) {};
	~VoltageXAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent4uhv *>(dev))->read_VoltageX(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent4uhv *>(dev))->is_VoltageX_allowed(ty);}
};

//	Attribute CurrentX class definition
class CurrentXAttrib: public Tango::Attr
{
public:
	CurrentXAttrib(const string &att_name):Attr(att_name.c_str(), 
			Tango::DEV_DOUBLE, Tango::READ) {};
	~CurrentXAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent4uhv *>(dev))->read_CurrentX(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent4uhv *>(dev))->is_CurrentX_allowed(ty);}
};

//	Attribute PressureX class definition
class PressureXAttrib: public Tango::Attr
{
public:
	PressureXAttrib(const string &att_name):Attr(att_name.c_str(), 
			Tango::DEV_DOUBLE, Tango::READ) {};
	~PressureXAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent4uhv *>(dev))->read_PressureX(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent4uhv *>(dev))->is_PressureX_allowed(ty);}
};

//	Attribute StateX class definition
class StateXAttrib: public Tango::Attr
{
public:
	StateXAttrib(const string &att_name):Attr(att_name.c_str(), 
			Tango::DEV_STATE, Tango::READ) {};
	~StateXAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent4uhv *>(dev))->read_StateX(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent4uhv *>(dev))->is_StateX_allowed(ty);}
};

//	Attribute StatusX class definition
class StatusXAttrib: public Tango::Attr
{
public:
	StatusXAttrib(const string &att_name):Attr(att_name.c_str(), 
			Tango::DEV_STRING, Tango::READ) {};
	~StatusXAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent4uhv *>(dev))->read_StatusX(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent4uhv *>(dev))->is_StatusX_allowed(ty);}
};

//	Attribute AutoStartX class definition
class AutoStartXAttrib: public Tango::Attr
{
public:
	AutoStartXAttrib(const string &att_name):Attr(att_name.c_str(), 
			Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~AutoStartXAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent4uhv *>(dev))->read_AutoStartX(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Agilent4uhv *>(dev))->write_AutoStartX(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent4uhv *>(dev))->is_AutoStartX_allowed(ty);}
};

//	Attribute ProtectX class definition
class ProtectXAttrib: public Tango::Attr
{
public:
	ProtectXAttrib(const string &att_name):Attr(att_name.c_str(), 
			Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~ProtectXAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent4uhv *>(dev))->read_ProtectX(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Agilent4uhv *>(dev))->write_ProtectX(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent4uhv *>(dev))->is_ProtectX_allowed(ty);}
};

//	Attribute FixedStepX class definition
class FixedStepXAttrib: public Tango::Attr
{
public:
	FixedStepXAttrib(const string &att_name):Attr(att_name.c_str(), 
			Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~FixedStepXAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent4uhv *>(dev))->read_FixedStepX(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Agilent4uhv *>(dev))->write_FixedStepX(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent4uhv *>(dev))->is_FixedStepX_allowed(ty);}
};

//	Attribute StatusSetPointX class definition
class StatusSetPointXAttrib: public Tango::Attr
{
public:
	StatusSetPointXAttrib(const string &att_name):Attr(att_name.c_str(), 
			Tango::DEV_BOOLEAN, Tango::READ) {};
	~StatusSetPointXAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent4uhv *>(dev))->read_StatusSetPointX(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent4uhv *>(dev))->is_StatusSetPointX_allowed(ty);}
};

//	Attribute InterlockStatusX class definition
class InterlockStatusXAttrib: public Tango::Attr
{
public:
	InterlockStatusXAttrib(const string &att_name):Attr(att_name.c_str(), 
			Tango::DEV_BOOLEAN, Tango::READ) {};
	~InterlockStatusXAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent4uhv *>(dev))->read_InterlockStatusX(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent4uhv *>(dev))->is_InterlockStatusX_allowed(ty);}
};

//	Attribute StatMaskX class definition
class StatMaskXAttrib: public Tango::Attr
{
public:
	StatMaskXAttrib(const string &att_name):Attr(att_name.c_str(), 
			Tango::DEV_LONG, Tango::READ) {};
	~StatMaskXAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent4uhv *>(dev))->read_StatMaskX(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent4uhv *>(dev))->is_StatMaskX_allowed(ty);}
};


//=========================================
//	Define classes for commands
//=========================================
//	Command OffHV1 class definition
class OffHV1Class : public Tango::Command
{
public:
	OffHV1Class(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	OffHV1Class(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~OffHV1Class() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Agilent4uhv *>(dev))->is_OffHV1_allowed(any);}
};

//	Command OffHV2 class definition
class OffHV2Class : public Tango::Command
{
public:
	OffHV2Class(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	OffHV2Class(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~OffHV2Class() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Agilent4uhv *>(dev))->is_OffHV2_allowed(any);}
};

//	Command OnHV1 class definition
class OnHV1Class : public Tango::Command
{
public:
	OnHV1Class(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	OnHV1Class(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~OnHV1Class() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Agilent4uhv *>(dev))->is_OnHV1_allowed(any);}
};

//	Command OnHV2 class definition
class OnHV2Class : public Tango::Command
{
public:
	OnHV2Class(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	OnHV2Class(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~OnHV2Class() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Agilent4uhv *>(dev))->is_OnHV2_allowed(any);}
};

//	Command OffHV3 class definition
class OffHV3Class : public Tango::Command
{
public:
	OffHV3Class(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	OffHV3Class(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~OffHV3Class() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Agilent4uhv *>(dev))->is_OffHV3_allowed(any);}
};

//	Command OffHV4 class definition
class OffHV4Class : public Tango::Command
{
public:
	OffHV4Class(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	OffHV4Class(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~OffHV4Class() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Agilent4uhv *>(dev))->is_OffHV4_allowed(any);}
};

//	Command OnHV3 class definition
class OnHV3Class : public Tango::Command
{
public:
	OnHV3Class(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	OnHV3Class(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~OnHV3Class() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Agilent4uhv *>(dev))->is_OnHV3_allowed(any);}
};

//	Command OnHV4 class definition
class OnHV4Class : public Tango::Command
{
public:
	OnHV4Class(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	OnHV4Class(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~OnHV4Class() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Agilent4uhv *>(dev))->is_OnHV4_allowed(any);}
};


/**
 *	The Agilent4uhvClass singleton definition
 */

#ifdef _TG_WINDOWS_
class __declspec(dllexport)  Agilent4uhvClass : public Serial2Client_ns::Serial2ClientClass
#else
class Agilent4uhvClass : public Serial2Client_ns::Serial2ClientClass
#endif
{
	/*----- PROTECTED REGION ID(Agilent4uhvClass::Additionnal DServer data members) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhvClass::Additionnal DServer data members

	public:
		//	write class properties data members
		Tango::DbData	cl_prop;
		Tango::DbData	cl_def_prop;
		Tango::DbData	dev_def_prop;
	
		//	Method prototypes
		static Agilent4uhvClass *init(const char *);
		static Agilent4uhvClass *instance();
		~Agilent4uhvClass();
		Tango::DbDatum	get_class_property(string &);
		Tango::DbDatum	get_default_device_property(string &);
		Tango::DbDatum	get_default_class_property(string &);
	
	protected:
		Agilent4uhvClass(string &);
		static Agilent4uhvClass *_instance;
		void command_factory();
		void attribute_factory(vector<Tango::Attr *> &);
		void pipe_factory();
		void write_class_property();
		void set_default_property();
		void get_class_property();
		string get_cvstag();
		string get_cvsroot();
	
	private:
		void device_factory(const Tango::DevVarStringArray *);
		void create_static_attribute_list(vector<Tango::Attr *> &);
		void erase_dynamic_attributes(const Tango::DevVarStringArray *,vector<Tango::Attr *> &);
		vector<string>	defaultAttList;
		Tango::Attr *get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname);
};

}	//	End of namespace

#endif   //	Agilent4uhv_H
